Skip to main content
`Ctrl`+`K`

# DMMoabFEMComputeBasis

Evaluate bases and derivatives at quadrature points for a linear EDGE/QUAD/TRI/HEX/TET element.

## Synopsis

    #include "petscdt.h"
    #include "petscdmmoab.h"
    PetscErrorCode DMMoabFEMComputeBasis(const PetscInt dim, const PetscInt nverts, const PetscReal *coordinates, const PetscQuadrature quadrature, PetscReal *phypts, PetscReal *jacobian_quadrature_weight_product, PetscReal *fe_basis, PetscReal **fe_basis_derivatives)

The routine takes the coordinates of the vertices of an element and computes basis functions associated with each quadrature point provided, and their derivatives with respect to X, Y and Z as appropriate.

## Input Parameters

- dim - the dimension

- nverts - the number of element vertices

- coordinates - the physical coordinates of the vertices (in canonical numbering)

- quadrature - the evaluation points (quadrature points) in the reference space

## Output Parameters

- phypts - the evaluation points (quadrature points) transformed to the physical space

- jacobian_quadrature_weight_product - the jacobian determinant * quadrature weight necessary for assembling discrete contributions

- fe_basis - the bases values evaluated at the specified quadrature points

- fe_basis_derivatives - the derivative of the bases wrt (X,Y,Z)-directions (depending on the dimension) evaluated at the specified quadrature points

## See Also

`DMMoabCreate()`

## Level

advanced

## Location

src/dm/impls/moab/dmmbfem.cxx

## Examples

src/ksp/ksp/tutorials/ex35.cxx
src/ksp/ksp/tutorials/ex36.cxx

Index of all DMMOAB routines
Table of Contents for all manual pages
Index of all manual pages